/* 
*  wowSim: Wireless on Wheel Simulator
*
*  COPYRIGHT: 
*  Roberta Fracchia, Dario Rossi (c) 2008 
*
*  LICENSE:    
*  GPL, see LICENSE.txt for details 
*
*  DISCLAIMER: 
*  THE SOFTWARE IS PROVIDED "AS IS".  IN NO EVENT SHALL AUTHORS BE LIABLE TO ANY PARTY 
*  FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST 
*  PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION. 
* 
*                                               _____________
*                                   ..---:::::::-----------. ::::;;.
*                                .'""""""                  ;;   \  ":.
*                             .''                          ;     \   "\__.
*                           .'                            ;;      ;   \\";
*                         .'                              ;   _____;   \\/
*                       .'                               :; ;"     \ ___:'.
*                     .'--...........................    : =   ____:"    \ \
*                ..-""                               """'  o"""     ;     ; :
*           .--""  .----- ..----...    _.-    --.  ..-"     ;       ;     ; ;
*        .""_-     "--""-----'""    _-"        .-""         ;        ;    .-.
*     .'  .'                      ."         ."              ;       ;   /. |
*    /-./'                      ."          /           _..  ;       ;   ;;;|
*   :  ;-.______               /       _________==.    /_  \ ;       ;   ;;;;
*   ;  / |      """"""""""".---."""""""          :    /" ". |;       ; _; ;;;
*  /"-/  |                /   /                  /   /     ;|;      ;-" | ;';
* :-  :   """----______  /   /              ____.   .  ."'. ;;   .-"..T"   .
* '. "  ___            "":   '""""""""""""""    .   ; ;    ;; ;." ."   '--"
*  ",   __ """  ""---... :- - - - - - - - - ' '  ; ;  ;    ;;"  ."
*   /. ;  """---___                             ;  ; ;     ;|.""
*  :  ":           """----.    .-------.       ;   ; ;     ;:
*   \  '--__               \   \        \     /    | ;     ;;
*    '-..   """"---___      :   .______..\ __/..-""|  ;   ; ;
*        ""--..       """--"        m l s         .   ". . ;
*              ""------...                  ..--""      " :
*                         """"""""""""""""""    \        /
*                                                "------"
* 
*  
*  ASCII-ART: courtesy of 
*  http://www.ascii-art.de/ascii/c/car.txt
*/

#include <stdio.h>
#include <stdlib.h>
#include "incl.h"

Coll *free_coll;

void in_list_coll(Coll **last, Coll *elem)
{
  if (elem==NULL) return;       /* Non c'e' nulla da inserire */
  DBG_PL(inlist,"coll:%d"),elem->id DBG_PR;

  /* L'Event List e' vuota: elem diventa l'Event List */
  if ((*last)==NULL)
    {
       (*last) = elem;
       (*last)->next = elem;
       (*last)->prev = elem;
       DBG_PL(inlist,"inserito coll:%d"),(*last)->id DBG_PR;       
       return;
   }

  /* 
  ** elem e' schedulato dopo l'ultimo evento presente in lista:
  ** viene inserito in fondo e diventa il nuovo last
  */
  elem->prev = (*last);
  elem->next = (*last)->next;
  ((*last)->next)->prev = elem;
  (*last)->next = elem;
  (*last) = elem;
   DBG_PL(inlist,"inserito 2 coll:%d"),(*last)->id DBG_PR;	 
  return;
}


Coll *out_list_coll(Coll **handle,int car)
{
  Coll *p;
  p = *handle;
  if (p==NULL) return(NULL);
  if (p->next==p)
    *handle = NULL;
  else
   {
    while(p->id!=car){
      p=p->next;
    }  
    p = (*handle)->next;
    (p->next)->prev = (*handle);   
    (*handle)->next = p->next;
   }
   
  DBG_PL(outlist,"coll:%d %p"),p->id,(*handle) DBG_PR;
  return(p);
}

Coll *out_list_coll2(Coll **handle)
{
  Coll *p;
  p = *handle;
  if (p==NULL) return(NULL);
  if (p->next==p)
    *handle = NULL;
  else
   {
    p = (*handle)->next;
    (p->next)->prev = (*handle);   
    (*handle)->next = p->next;
   }
  return(p);
}



//Dato l'id della macchina, trova la struttura corrispondente
Coll *find_coll(Coll **last,int id) {
  Coll *p;
  
  /*DBG_I(FindCar);
  DBG_PL(FindCar,"time:%f"),current_time DBG_PR;
  DBG_PL(FindCar,"Id_car :%d"),id DBG_PR;*/
  
  p = (*last);
  //DBG_PL(findcoll,"c:%d %p"),p->id,  p DBG_PR;       
  
  do {
    //DBG_PL(findcoll,"c:%d %p"),p->id, p DBG_PR;
    if ( p->id ==id){ 
      return p;
    }   
    p=p->prev;
    } while (p!=(*last));

  return NULL;
  
/*DBG_X(FindCar);*/
}





Coll *new_coll(void)
{
#define BUNCHSIZE 60
 extern Coll *free_coll;
 Coll *p,*q;
 int i;
 if (free_coll==NULL)
  {
    if ((p=(Coll *)malloc(sizeof(Coll)))==NULL)
         { 
	   fprintf(stderr,"Memory allocation failed in new_coll()\n");
           exit(1);
         }
    p->next = NULL;
    free_coll = p;
    q = p; 
    for (i=0; i<BUNCHSIZE ; i++)
     {
       if ((p=(Coll *)malloc(sizeof(Coll)))==NULL)
         { fprintf(stderr,"Memory allocation failed in new_coll()\n");
           exit(1);
         }
       p->next = q;
       q = p;
     }
    free_coll->next = q;
  }
 return(out_list_coll2(&free_coll));
#undef BUNCHSIZE
}

void release_coll(Coll *element)
{
 extern Coll *free_coll;
 in_list_coll(&free_coll,element);
}
