/* 
*  wowSim: Wireless on Wheel Simulator
*
*  COPYRIGHT: 
*  Roberta Fracchia, Dario Rossi (c) 2008 
*
*  LICENSE:    
*  GPL, see LICENSE.txt for details 
*
*  DISCLAIMER: 
*  THE SOFTWARE IS PROVIDED "AS IS".  IN NO EVENT SHALL AUTHORS BE LIABLE TO ANY PARTY 
*  FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST 
*  PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION. 
* 
*                                               _____________
*                                   ..---:::::::-----------. ::::;;.
*                                .'""""""                  ;;   \  ":.
*                             .''                          ;     \   "\__.
*                           .'                            ;;      ;   \\";
*                         .'                              ;   _____;   \\/
*                       .'                               :; ;"     \ ___:'.
*                     .'--...........................    : =   ____:"    \ \
*                ..-""                               """'  o"""     ;     ; :
*           .--""  .----- ..----...    _.-    --.  ..-"     ;       ;     ; ;
*        .""_-     "--""-----'""    _-"        .-""         ;        ;    .-.
*     .'  .'                      ."         ."              ;       ;   /. |
*    /-./'                      ."          /           _..  ;       ;   ;;;|
*   :  ;-.______               /       _________==.    /_  \ ;       ;   ;;;;
*   ;  / |      """"""""""".---."""""""          :    /" ". |;       ; _; ;;;
*  /"-/  |                /   /                  /   /     ;|;      ;-" | ;';
* :-  :   """----______  /   /              ____.   .  ."'. ;;   .-"..T"   .
* '. "  ___            "":   '""""""""""""""    .   ; ;    ;; ;." ."   '--"
*  ",   __ """  ""---... :- - - - - - - - - ' '  ; ;  ;    ;;"  ."
*   /. ;  """---___                             ;  ; ;     ;|.""
*  :  ":           """----.    .-------.       ;   ; ;     ;:
*   \  '--__               \   \        \     /    | ;     ;;
*    '-..   """"---___      :   .______..\ __/..-""|  ;   ; ;
*        ""--..       """--"        m l s         .   ". . ;
*              ""------...                  ..--""      " :
*                         """"""""""""""""""    \        /
*                                                "------"
* 
*  
*  ASCII-ART: courtesy of 
*  http://www.ascii-art.de/ascii/c/car.txt
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "incl.h"

extern void schedule(int, double,EventParam);
extern double uniform(double,double,long *);


void hello_rx_end(EventParam par_in) {

  Car *p_rx; //car that is receiving the warning*/
  Coll *othercol,*coll;
    
  //DBG_I(HelloRxEnd);
  //DBG_PL(HelloRxEnd,"time:%f (mus)  car:%d"),current_time,par_in.id DBG_PR;
  p_rx=par_in.ptr;
  
  /*the received warning collided*/ 
  if (p_rx->CAR_State==COLL){ 
 
         //DBG_PL(HelloRxEnd,"car coll:%d  maxadv:%f"), par_in.id,maxadvised DBG_PR;
         
         /*to update the statistics: creation of a list of cars with 1 pkt collided.
	 When the second collided packet arrives the car is removed from the list.*/
	 
	 if (collision!=NULL)
	     othercol=find_coll(&collision,par_in.id);
         else
	     othercol=NULL;
	 
	 /*if it is in the list and there is collision -> it is the second one ->remove it*/
	 if(othercol!=NULL){
            //DBG_PL(HelloRxEnd,"othercoll:%d"),othercol->id DBG_PR;
            coll = out_list_coll(&collision,p_rx->id);
            release_coll(coll);

	 /*if it is not in the list and there is collision ->insert it*/
	 } else {
	   coll = new_coll();
	   coll->id=par_in.id;
	   in_list_coll(&collision,coll);  
         }
        //DBG_PL(HelloRxEnd,"car %d is colliding..."), par_in.id DBG_PR;

  } else {       
      if (channel_error(par_in.id,par_in.idTx)) {
              DBG_PL(RxEnd,"pacchetto perso!!") DBG_PR;	   
      }else{
	 p_rx->vicPos[par_in.idTx]     = par_in.xTx;
	 p_rx->vicSpeed[par_in.idTx]   = par_in.vTx;
	 p_rx->HelloTxTime[par_in.idTx]= par_in.tTx;      
	 p_rx->myPos[par_in.idTx]   = p_rx->x;
	 p_rx->mySpeed[par_in.idTx] = p_rx->v;
	 Car *hello_tx = find_car(&queue, par_in.idTx);

	 //printf("A%d:%d:%d\n" , p_rx->HelloC[par_in.idTx], hello_tx->MyHelloC, par_in.ptr->MyHelloC);

	 p_rx->HelloC[par_in.idTx]     = hello_tx->MyHelloC;
	 //p_rx->HelloC[par_in.idTx]   = par_in.ptr->MyHelloC;
	 if(par_in.xTx<p_rx->minPos)
           p_rx->minPos=par_in.xTx;

	 //DBG_PL(HelloRxEnd,"HtxTime:%f  speed:%f  pos:%f  C:%d id%d (io:%d)" ),\
	 p_rx->HelloTxTime[par_in.idTx],p_rx->vicSpeed[par_in.idTx],p_rx->vicPos[par_in.idTx],\
	 p_rx->HelloC[par_in.idTx], par_in.idTx, par_in.ptr->id DBG_PR; 		 
     }
  }
  p_rx->pkt_inrx--;
  if(p_rx->pkt_inrx==0)
       p_rx->CAR_State=DRIVE;
	    
  //DBG_X(HelloRxEnd);

}

void hello_rx(EventParam par_in) {
  Car *p;  /*receiving car*/
  double rxend;
  
  //DBG_I(HelloRx);
  p=par_in.ptr;
  //DBG_PL(HelloRx,"RX_INIT car:%d state:%d"),p->id,p->CAR_State DBG_PR;
  
  
  if(p->CAR_State==TX) {
     //DBG_PL(HelloRx,"car %d is transmitting..."),par_in.id DBG_PR;
  } else {
     p->pkt_inrx++;
       if(p->CAR_State==RX){ /*if it is already receiving a packet, they will colide*/
 	 p->CAR_State=COLL;
       }       else { 
 	 p->CAR_State=RX;     /*else the reception starts*/ 
       }
     rxend=current_time+txTimeHello;
     p->RxEND=rxend;

     schedule(HELLO_RX_END,rxend,par_in);
  }
  //DBG_X(HelloRx);

}


void hello_tx(EventParam par_in) {
  Car *p,*p_tx;      
  int go_on ;
  double distanceNow;
  double propTime,nexttime;
  double rxposition_later;
  EventParam hello_par;
    
  //DBG_I(HelloTx);
  //DBG_PL(HelloTx,"time:%f (mus)  car:%d"),current_time,par_in.id DBG_PR;

  p_tx=par_in.ptr;
  
  if(current_time>timeFirstAccident)
   return;
  
  go_on=1;
  p = queue;  
  do {
  
     distanceNow=fabs(p_tx->position-p->position);
     propTime=distanceNow/(3.0*1e2);
     double end=p->TxEND+propTime;
     if(abs(p_tx->position-p->position)<range && ((p->CAR_State==TX) || 
       ((p->CAR_State==RX) && ((end)>=(current_time)) ))) {
	/*someone else is transmitting: we tray later on */
	//DBG_PL(HelloTx,"Car[%d] is transmitting"),p->id DBG_PR;	
	go_on=0;
	nexttime=uniform(0,31,&seed)*SlotTime+current_time;			
	//DBG_PL(HelloTx,"Try again at %f (mus)"),nexttime DBG_PR;			       
	schedule(HELLO_TX,nexttime, par_in);
     }
   p=p->prev;   
   } while (p!=queue && go_on==1);		  

   if(go_on==1) {
       p_tx->CAR_State=TX;  /*the car starts the transmission*/
       p_tx->MyHelloC++;
       if(p_tx->MyHelloC > HelloCounter)
          HelloCounter=p_tx->MyHelloC;
       //DBG_PL(HelloTx,"TX_INIT car:%d sposition:%f"),p_tx->id, p_tx->position DBG_PR;

       /*the end of the transmission is scheduled*/
       schedule(HELLO_TX_END,current_time+txTimeHello,par_in);

       //DBG_PL(HelloTx,"Nel range:") DBG_PR;

       p = queue;
       /*search of all the cars in the rx range*/
       if (queue!=NULL)  /*first car to see the accident*/
       do {
  	     if(p!=p_tx){
		  distanceNow=fabs(p_tx->position-p->position);
		  propTime=distanceNow/(3.0*1e2);

	          /*----------------boh???????----------------*/
	          rxposition_later=p->position+p->v*traffic.cell/(traffic.step*ONE_SECOND)*(propTime+txTimeHello);

		  if(distanceNow < range  && p->CAR_State!=TX && rxposition_later<=STREET_LENGTH){
	               double rxtime;
		       rxtime=current_time+propTime;
	               //DBG_PL(HelloTx,"propTime:%le"), propTime DBG_PR;
	               //DBG_PL(HelloTx,"car[%d]: w:%d distance=%f  rxtime:%f (mus)"),p->id,p->warning,distanceNow,rxtime DBG_PR;

		       hello_par.ptr = p;
		       hello_par.id  = p->id;
		       hello_par.idTx= p_tx->id;
		       hello_par.vTx = p_tx->v;
		       hello_par.xTx = p_tx->x;
		       hello_par.tTx = lastUpdate;
		       		       
		       schedule(HELLO_RX,rxtime,hello_par);
       	  } 
	     }	
	 p=p->prev;
	} while (p!=queue);

  } 
}

void hello_tx_end(EventParam par_in) {
  Car *p;
  p=par_in.ptr;
  p->CAR_State=DRIVE;
  //DBG_PL(HelloTxEnd,"time:%f (mus)  car:%d"),current_time,par_in.id DBG_PR;
}


void hello() {
  Car *p;      
  double backoff;
  int i;
  EventParam hello_par;
    
  //DBG_I(Hello);
  p = queue;
  if (queue!=NULL)  
  do {
    hello_par.ptr = p;
    hello_par.id = p->id;
    backoff=uniform(0,1,&seed)*HelloFreq*(double)ONE_SECOND;
    
    if(p->warning==0)
	schedule(HELLO_TX,current_time+backoff,hello_par);

    if((algo == ALGO_HELP) || (algo == ALGO_HYBRID)){
	for(i=0;i<MAX_CICLI_HELLO; i++){
	  backoff+=HelloFreq*(double)ONE_SECOND;
	  schedule(HELLO_TX,current_time+backoff,hello_par);
	  //printf("time hello:%f  ",timeHello);
	}
    }

    p=p->prev;
    } while (p!=queue);
  //DBG_X(Hello);
  
}

