/* 
*  wowSim: Wireless on Wheel Simulator
*
*  COPYRIGHT: 
*  Roberta Fracchia, Dario Rossi (c) 2008 
*
*  LICENSE:    
*  GPL, see LICENSE.txt for details 
*
*  DISCLAIMER: 
*  THE SOFTWARE IS PROVIDED "AS IS".  IN NO EVENT SHALL AUTHORS BE LIABLE TO ANY PARTY 
*  FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST 
*  PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION. 
* 
*                                               _____________
*                                   ..---:::::::-----------. ::::;;.
*                                .'""""""                  ;;   \  ":.
*                             .''                          ;     \   "\__.
*                           .'                            ;;      ;   \\";
*                         .'                              ;   _____;   \\/
*                       .'                               :; ;"     \ ___:'.
*                     .'--...........................    : =   ____:"    \ \
*                ..-""                               """'  o"""     ;     ; :
*           .--""  .----- ..----...    _.-    --.  ..-"     ;       ;     ; ;
*        .""_-     "--""-----'""    _-"        .-""         ;        ;    .-.
*     .'  .'                      ."         ."              ;       ;   /. |
*    /-./'                      ."          /           _..  ;       ;   ;;;|
*   :  ;-.______               /       _________==.    /_  \ ;       ;   ;;;;
*   ;  / |      """"""""""".---."""""""          :    /" ". |;       ; _; ;;;
*  /"-/  |                /   /                  /   /     ;|;      ;-" | ;';
* :-  :   """----______  /   /              ____.   .  ."'. ;;   .-"..T"   .
* '. "  ___            "":   '""""""""""""""    .   ; ;    ;; ;." ."   '--"
*  ",   __ """  ""---... :- - - - - - - - - ' '  ; ;  ;    ;;"  ."
*   /. ;  """---___                             ;  ; ;     ;|.""
*  :  ":           """----.    .-------.       ;   ; ;     ;:
*   \  '--__               \   \        \     /    | ;     ;;
*    '-..   """"---___      :   .______..\ __/..-""|  ;   ; ;
*        ""--..       """--"        m l s         .   ". . ;
*              ""------...                  ..--""      " :
*                         """"""""""""""""""    \        /
*                                                "------"
* 
*  
*  ASCII-ART: courtesy of 
*  http://www.ascii-art.de/ascii/c/car.txt
*/
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "statist.h"
#include "incl.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *debug_file_stat,*fileout,*fileout2; 

void init_stat(void);
void out_global_results(void);

extern void end_simulation_run(void);
/* identificazione della variabile
                         0 -> Total delay
                         1 -> Total throughput per input
                         2 -> Total probability of loss
                         3 -> P(delay>2*OQ)
*/
void end_trans0(void)
     {
      stat_flag= STAT_ON;         
     
     printf("\rFine transitorio 0");
     }
void end_trans1(void) 
{
    if (stat_flag==STAT_OFF) {
        stat_flag=STAT_ALMOST_ON;
    } else {
        stat_flag= STAT_ON;
    }
    
    printf("\rFine transitorio 1");
}
void end_trans2(void) 
{
    if (stat_flag==STAT_OFF) {
        stat_flag=STAT_ALMOST_ON;
    } else {
        stat_flag= STAT_ON;
    }
    
    printf("\rFine transitorio 2");
}

void end_trans4(void) 
{
    if (stat_flag==STAT_OFF) {
        stat_flag=STAT_ALMOST_ON;
    } else {
        stat_flag= STAT_ON;
    }
    
    printf("\rFine transitorio 4");
}
void end_trans3(void) 
{
    if (stat_flag==STAT_OFF) {
        stat_flag=STAT_ALMOST_ON;
    } else {
        stat_flag= STAT_ON;
    }
    
    printf("\rFine transitorio 3");
}


void ea0(void) {
    static int once=0;
    
    if (once==0) {
        once=1;
    }
}

void ea1(void) {
    static int once=0;
    
    if (once==0) {
        once=1;
    }
}

void ea2(void) {
    static int once=0;
    
    if (once==0) {
        once=1;
    }
}

void ea3(void) {
    static int once=0;
    
    if (once==0) {
        once=1;
    }
}
void ea4(void) {
    static int once=0;
    
    if (once==0) {
        once=1;
    }
}

int n_stat_var=9;

Booltype significant_var[]={FALSE,TRUE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE}; // delay, informed

char *var_names[]={"density","perc. informed","max distance","end x noone further",
"end x coll","end x notx","info","totW","fail"};
void (*end_transient[])()={end_trans0,end_trans1,end_trans2,end_trans3,end_trans4,end_trans4,
                          end_trans4,end_trans4,end_trans4};
void (*end_analysis[])()={ea0,ea1,ea2,ea3,ea4,ea4,ea4,ea4,ea4};



void init_stat(void)
     { 
     // inizializza tutte le varaibili statistiche ad ogni inizio di simulazione
      int i;
      
      for(i=0;i<100;i++){
         W[i]=0;
         Wrel[i]=0;
	 C[i]=0;
	 WC[i][i]=0;
	 }
     tot_noinfo_backoorange=tot_noinfo_backcoll=0;
     tot_noinfo_other=tot_noinfo_notx=0;

     init_statistics(n_stat_var,significant_var,var_names,
                     end_transient,end_analysis,end_simulation_run,NULL);
     set_ref_accuracy(REF_ACCURACY); //0.05
     set_confid_lev(CONFID_LEV); //2->0.95

     set_max_coll_obs(MAX_COLL_OBS); //100000
     set_min_coll_obs(MIN_COLL_OBS); 
     set_min_transient_length(MIN_TRANSIENT_LENGTH); //50000
     set_tr_bat_size(TR_BAT_SIZE); //30
     set_tr_accuracy(TR_ACCURACY); //0.9
     /*-----------*/
     
     set_tr_seq_len(3); //15
     set_st_bat_size(1000); //ogni quanti campioni (esaurito il transitorio)
                           //controlla l'intervallo di confidenza
     }


void out_global_results(void)
     {
        int i;
	int tot=0,tot_relay=0;       
	int tot_info=0,tot_info_relay=0;  /*informed cars*/
        int tot_coll_noinfo=0; /*non-informed beacause collided*/
	int tot_dup=0;   /*informed cars with duplicate warnings*/
	int tot_dup_relay=0;   /*informed cars with duplicate warnings*/
	int tot_coll=0;  /*cars that received collided warnings (then informed or not)*/
	
	double avg_info,avg_info_relay;         /*average number of informed cars*/
	double avg_dup,avg_dup_relay;          /*average number of cars with duplicate info*/
	double avg_dup_info;     /*Prob that an informed car receives a duplicate warning*/
	double avg_dup_info_relay;     /*Prob that an informed car receives a duplicate warning*/
	double avg_carw[100],avg_carw_info[100],avg_carc[100],avg_carw_relay[100];
	double avg_coll;         /*average number of cars with duplicate info*/
	double avg_coll_noinfo;  /*average number of cars with collided info, not informed*/
	double avg_coll_noinfo_noinfo;  /*P(car not informed bacause of collision)*/
        double avg_noinfo_others,avg_noinfo_others_noinfo;       /*P(car not informed for other reasons)*/
	double avg_noinfo_backoorange,avg_noinfo_backoorange_noinfo;
	double avg_noinfo_backcoll,avg_noinfo_backcoll_noinfo;
	double avg_noinfo_notx,avg_noinfo_notx_noinfo;

        int altri;
	
	printf("Total delay: mean %g dev_std %g acc %g #%ld\n",
               curr_mean(0),sqrt(curr_variance(0)),curr_accuracy(0),
               curr_nr_of_samples(0));
        printf("Total informed cars: mean %g dev_std %g acc %g #%ld\n",
               curr_mean(1),sqrt(curr_variance(1)),curr_accuracy(1),
               curr_nr_of_samples(1));
        fprintf(fileout,"Pf      maxD   range   txRate\n");
        fprintf(fileout,"%1.1f\t%.0f\t%ld\t%g\n\n",Pflood,STREET_LENGTH,range,txRate);
        fprintf(fileout,"#Density\n");
        fprintf(fileout,"%f\t%f\t%f\n\n",curr_mean(0),sqrt(curr_variance(0)),curr_accuracy(0));        
	fprintf(fileout,"#  informed cars (perc.)\n");
	fprintf(fileout,"%f\t%f\t%f\n\n\n",curr_mean(1),sqrt(curr_variance(1)),curr_accuracy(1));
	fprintf(fileout,"#  max distance\n");
	fprintf(fileout,"%f\t%f\t%f\n\n\n",curr_mean(2),sqrt(curr_variance(2)),curr_accuracy(2));

	fprintf(fileout,"#end x noone\n");
	fprintf(fileout,"%f\t%f\t%f\n\n\n",curr_mean(3),sqrt(curr_variance(3)),curr_accuracy(3));
	fprintf(fileout,"#end x coll\n");
	fprintf(fileout,"%f\t%f\t%f\n\n\n",curr_mean(4),sqrt(curr_variance(4)),curr_accuracy(4));
	fprintf(fileout,"#end x notx\n");
	fprintf(fileout,"%f\t%f\t%f\n\n\n",curr_mean(5),sqrt(curr_variance(5)),curr_accuracy(5));
	fprintf(fileout,"#avg. info\n");
	fprintf(fileout,"%f\t%f\t%f\n\n\n",curr_mean(6),sqrt(curr_variance(6)),curr_accuracy(6));
	fprintf(fileout,"#Generated Warnings\n");
	fprintf(fileout,"%f\t%f\t%f\n\n\n",curr_mean(7),sqrt(curr_variance(7)),curr_accuracy(7));
	fprintf(fileout,"#Prob. failing in decision\n");
	fprintf(fileout,"%f\t%f\t%f\n\n\n",curr_mean(8),sqrt(curr_variance(8)),curr_accuracy(8));

	
      for(i=1;i<100;i++){
	    tot_info+=W[i];
	    tot_info_relay+=Wrel[i];
      }
	      
      for(i=0;i<100;i++){
	    tot+=W[i];
	    tot_relay+=Wrel[i];
      }
      avg_info=(double)tot_info/(double)tot;   
      avg_info_relay=(double)tot_info_relay/(double)tot_relay;   
      
      for(i=2;i<100;i++){
	 tot_dup+=W[i];
	 tot_dup_relay+=Wrel[i];
	 
      }   
      avg_dup=(double)tot_dup/(double)tot;
      avg_dup_relay=(double)tot_dup_relay/(double)tot_relay;
      avg_dup_info=(double)tot_dup/(double)tot_info;
      avg_dup_info_relay=(double)tot_dup_relay/(double)tot_info_relay;
      
      for(i=0;i<100;i++){
	 avg_carw[i]=(double)W[i]/(double)tot;
	 avg_carw_relay[i]=(double)Wrel[i]/(double)tot_relay;
	 avg_carw_info[i]=(double)W[i]/(double)tot_info;
      }
      
      for(i=1;i<100;i++){
	 tot_coll+=C[i];
	 tot_coll_noinfo+=WC[0][i];
	 avg_carc[i]=(double)C[i]/(double)tot;
      }   
      avg_coll=(double)tot_coll/(double)tot;
      avg_coll_noinfo_noinfo=(double)tot_coll_noinfo/((double)tot-tot_info);
      avg_coll_noinfo=(double)tot_coll_noinfo/(double)tot;
      
      
	 altri=tot-tot_info-tot_coll_noinfo-tot_noinfo_backoorange-tot_noinfo_backcoll-tot_noinfo_notx;
      avg_noinfo_backoorange=(double)tot_noinfo_backoorange/(double)tot;
      avg_noinfo_backoorange_noinfo=(double)tot_noinfo_backoorange/((double)tot-tot_info);
      avg_noinfo_backcoll=(double)tot_noinfo_backcoll/(double)tot;
      avg_noinfo_backcoll_noinfo=(double)tot_noinfo_backcoll/((double)tot-tot_info);
      avg_noinfo_notx=(double)tot_noinfo_notx/(double)tot;
      avg_noinfo_notx_noinfo=(double)tot_noinfo_notx/((double)tot-tot_info);
 
	 avg_noinfo_others=altri/(double)tot;
      avg_noinfo_others_noinfo=(double)altri/((double)tot-tot_info);
      /*avg_noinfo_others_noinfo=1.0 - avg_coll_noinfo_noinfo- avg_noinfo_backoorange_noinfo 
	      - avg_noinfo_backcoll_noinfo- avg_noinfo_notx_noinfo;*/
      
      fprintf(fileout,"#Informed  rx_dup  rx_dup/info  rx_dup/info(r) rx_coll\n");
      fprintf(fileout,"%f   %f  %f   %f\t%f\n\n\n",avg_info,avg_dup,avg_dup_info,avg_dup_info_relay,avg_coll);
 
 
      
 
		       

 }
