/* 
*  wowSim: Wireless on Wheel Simulator
*
*  COPYRIGHT: 
*  Roberta Fracchia, Dario Rossi (c) 2008 
*
*  LICENSE:    
*  GPL, see LICENSE.txt for details 
*
*  DISCLAIMER: 
*  THE SOFTWARE IS PROVIDED "AS IS".  IN NO EVENT SHALL AUTHORS BE LIABLE TO ANY PARTY 
*  FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST 
*  PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION. 
* 
*                                               _____________
*                                   ..---:::::::-----------. ::::;;.
*                                .'""""""                  ;;   \  ":.
*                             .''                          ;     \   "\__.
*                           .'                            ;;      ;   \\";
*                         .'                              ;   _____;   \\/
*                       .'                               :; ;"     \ ___:'.
*                     .'--...........................    : =   ____:"    \ \
*                ..-""                               """'  o"""     ;     ; :
*           .--""  .----- ..----...    _.-    --.  ..-"     ;       ;     ; ;
*        .""_-     "--""-----'""    _-"        .-""         ;        ;    .-.
*     .'  .'                      ."         ."              ;       ;   /. |
*    /-./'                      ."          /           _..  ;       ;   ;;;|
*   :  ;-.______               /       _________==.    /_  \ ;       ;   ;;;;
*   ;  / |      """"""""""".---."""""""          :    /" ". |;       ; _; ;;;
*  /"-/  |                /   /                  /   /     ;|;      ;-" | ;';
* :-  :   """----______  /   /              ____.   .  ."'. ;;   .-"..T"   .
* '. "  ___            "":   '""""""""""""""    .   ; ;    ;; ;." ."   '--"
*  ",   __ """  ""---... :- - - - - - - - - ' '  ; ;  ;    ;;"  ."
*   /. ;  """---___                             ;  ; ;     ;|.""
*  :  ":           """----.    .-------.       ;   ; ;     ;:
*   \  '--__               \   \        \     /    | ;     ;;
*    '-..   """"---___      :   .______..\ __/..-""|  ;   ; ;
*        ""--..       """--"        m l s         .   ". . ;
*              ""------...                  ..--""      " :
*                         """"""""""""""""""    \        /
*                                                "------"
* 
*  
*  ASCII-ART: courtesy of 
*  http://www.ascii-art.de/ascii/c/car.txt
*/
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <assert.h>
#include <time.h>
#include <signal.h>

#define DECLARE_VAR
#include "incl.h"



/*----------------------------------------------*/

extern double uniform(double,double,long *);
extern double uniform01(long *);
extern double negexp(double,long *);
extern int geometric1(double,long *);

extern void input_parameters(int, char**);
extern void carExit(void);
extern void car_arrival(int);

extern void init_stat();
extern void init_var();
extern void out_global_results();
extern void schedule(int, double, EventParam);
/*----------------------------------------------*/
	

void measure(void) {

Car *p;
double vsum=0;
traffic.rhoc=0;
int slot=current_time/(traffic.step*ONE_SECOND);
if (queue==NULL)
       return;

p=queue->next;
DBG_PL(Measure,"lastUpdate (%f) now slot:%d "),lastUpdate,slot DBG_PR;
do{
   //DBG_PL(Measure,"id:%d p:pos %f v:%f"),p->id,p->position,p->v DBG_PR;
   if( p->position<MP && p->position>MP-SecurityArea){      
      vsum+=p->v;
      traffic.rhoc++;
      //DBG_PL(Measure,"vsum:%f rhoc:%d"),vsum,traffic.rhoc  DBG_PR;      
   }
   p=p->next;      
}while(p!=queue->next);

if(traffic.rhoc>0)
  traffic.v=vsum/traffic.rhoc;
else
  traffic.v=vsum;

traffic.density=traffic.rhoc/SecurityArea*1000;  //car/km
traffic.flow=traffic.density*traffic.v*traffic.cell/traffic.step*3.6;   //car/h

 if (algo==ALGO_NONE) {
      fprintf(diaf,"%f %f %f\n",traffic.density,traffic.flow,traffic.v*traffic.cell/traffic.step*3.6);
      histo_add(H_velocity,   traffic.v*traffic.cell/traffic.step*3.6);
      histo_add(H_density, traffic.density);
      histo_add(H_flow,    traffic.flow);
 }    

DBG_PL(Measure,"vsum:%f rhoc:%d"),vsum,traffic.rhoc  DBG_PR; 
//DBG_PL(Measure,"(%f) %f %f"),lastUpdate,traffic.density,traffic.flow  DBG_PR;
}


int evalPos(void){
  int pos;

  do{ 
      pos=floor(uniform(0.0,STREET_LENGTH/traffic.cell,&seed));
  }while(vettPos[pos]!=0);
  
  prec=pos;
  vettPos[pos]=1;
  return pos;
}


void update(void)
{ 
  Car *oldest;
  int pos;
  EventParam par;
  par.id=-1;
  par.ptr=NULL;
  
  //DBG_I(Update);
    
  if (current_time==0 && traffic.model > TRAFFIC_NBNA){
	 while (((double)system_cars+1) <= system_rho*STREET_LENGTH/1000) {
	    pos=evalPos();
	    car_arrival(pos);	    
	 }     
 }else{
    updatePosition(&queue);
    lastUpdate=current_time;
 }
  
  if(total_cars>0 &&  traffic.model > TRAFFIC_NBNA){
     oldest=queue->next;
     //DBG_PL(Update,"oldestPos:%f"),oldest->position DBG_PR;
     while( oldest->position >= STREET_LENGTH){
         //DBG_PL(Update,"CIRCULAR-SHIT") DBG_PR;
	 oldest->x = oldest->x-STREET_LENGTH/traffic.cell; 
	 oldest->position = 0;
	 oldest->arrival = current_time;
	 //oldest->id = ++total_cars;
	 queue = queue->next;
         oldest=queue->next;
     }
  }	

  int slot=current_time/(traffic.step*ONE_SECOND);
  if (slot>100)
     measure();

  /*per bloccare la simulazione dopo l'incidente*/
  if((current_time+traffic.step*ONE_SECOND)<timeFirstAccident){
      schedule(UPDATE,current_time+traffic.step*ONE_SECOND,par);
  }
  
  //DBG_X(Update);
  return;
}





/*Incidente in un punto qualsiasi e parte il warning dalla macchina + vicina
(che puo' essere la macchina coinvolta)*/
void accident(void)
{
  double distanceNow; /*actual distance between tx and rx cars*/
  double rxposition_later;  /*positions of tx and rx cars
                                              at the end of the transmission*/
  double propTime;
  int someoneBack=0;  /*it is ==1 if one or more cars receive the warining*/
  Car *p = queue;
  EventParam par;
  
  DBG_I(Accident);

  timeAccident=current_time;
  totW++;
  DBG_PL(Accident,"time:%f (mus)  position:%.0f  cars:%d"),current_time,STREET_LENGTH,traffic.rhoc  DBG_PR;
  
  measure();
  d_statistics(0,traffic.density);
  if(current_time==timeFirstAccident)
     cars_accidentTime=traffic.rhoc;
  DBG_PL(Accident,"time:%f (mus)  position:%.0f  cars:%d"),current_time,STREET_LENGTH,traffic.rhoc  DBG_PR;
  
  /*search of all the cars in the rx range*/
  if (queue!=NULL) { /*first car to see the accident*/
     do {
        if(p->position>(STREET_LENGTH-SecurityArea)){
	   distanceNow=fabs(STREET_LENGTH-p->position);
	   propTime=distanceNow/(3.0*1e2);

	   
	   /*----------------boh????------------------*/
	   rxposition_later=p->position+p->v*traffic.cell/(traffic.step*ONE_SECOND)*(propTime+txTime);

	   /*this car will receive the  warning only if in the tx range both at the beginning and at
	   the end of the transmission*/
	   /*other checks: - the car can not receive the warning if it is already transmitting
	        	   - cars that pass the accident before the end of the reception of the warning 
			     are not considered*/
	   if(distanceNow < range  && p->CAR_State!=TX && rxposition_later<=STREET_LENGTH && 
	        p->position>STREET_LENGTH-SecurityArea){
		if(algo == ALGO_D2FLOOD || algo == ALGO_D3FLOOD){
		   if(distanceNow<p->minDist||p->minDist==0){
		      p->minDist=distanceNow;
		   }

		   /* back the old times of AWSN, it was that way 
		   Pflood = p->minDist/range;
		   Pflood = (k_d2flood<0) ? 1.0 : 1.0-pow((1.0-Pflood),k_d2flood+0.0);
		   */
		   Pflood = (algo == ALGO_D3FLOOD) ? 
		     	      d3flood_pfwd(p->minDist/range, p->v/traffic.vmax) :
		     	      d2flood_pfwd(p->minDist/range, p->v/traffic.vmax);
  
		  
		   DBG_PL(Accident,"min dist:%f  pf:%f"), p->minDist,Pflood DBG_PR;
		}
		
		double rxtime;
		rxtime=propTime+timeAccident;
		DBG_PL(Accident,"propTime:%f Accident:%f (mus)"),propTime,timeAccident DBG_PR;
		DBG_PL(Accident,"car[%d]: w:%d distance=%f  rxtime:%f (propTime:%f) (mus)"),p->id,p->warning,distanceNow,
	           rxtime,propTime DBG_PR;
		DBG_PL(Accident,"schedule: %f %d %d %f 0"), rxtime,p->id,0,Pflood DBG_PR;
		
		par.ptr  = p;
		par.id   = p->id;
		par.Pf   = Pflood;
		par.xTx  = STREET_LENGTH;
		par.vTx  = 0;
		par.idTx = -1; 		
		schedule(RX_INIT,rxtime,par);

		someoneBack++;  
	   }
        }	     	
     p=p->prev;
     } while (p!=queue);
  }
  if(someoneBack==0){
     DBG_PL(Accident,"Noone is listening") DBG_PR;
     endxnoone_further=1;
     endxcoll=0;
     endxnotx=0;
  }
  
  carback=traffic.rhoc;
     	
  DBG_X(Accident);
  return;
}


void tx_init(EventParam par_in)
{
  Car *p;      /*receiving car*/
  Car *p_tx;  /*transmitting car*/
  double distanceNow; /*actual distance between tx and rx cars*/
  double rxposition_later;  /*positions of tx and rx cars
                                              at the end of the transmission*/
  double propTime;
  int someoneBack=0;  /*it is ==1 if one or more cars receive the warining*/
  int carback_new;
  EventParam par;  
  
  DBG_I(TxInit);
  DBG_PL(TxInit,"time:%f (mus)"),current_time DBG_PR;
    
  totW++;
    
  p_tx=par_in.ptr;
  if( H_dRelay >=0){ 
     Dfwd[(int)p_tx->x]=1;
  }

  
  
  carback_new=carsComputing(&queue,p_tx->position);
     
  p_tx->CAR_State=TX;  /*the car starts the transmission*/
    
  /*the end of the transmission is scheduled*/
  
  
  schedule(TX_END,current_time+txTime,par_in);
  
  DBG_PL(TxInit,"TX_INIT car:%d sposition:%f"),p_tx->id, p_tx->position DBG_PR;
  DBG_PL(TxInit,"Nel range:") DBG_PR;  
  p = queue;    
  /*search of all the cars in the rx range*/
  if (queue!=NULL)  /*first car to see the accident*/
  do {
  	if(p!=p_tx&&p->position>(STREET_LENGTH-SecurityArea)){
	     distanceNow=fabs(p_tx->position-p->position);
	     propTime=distanceNow/(3.0*1e2);
	     
	     
	    /*----------------boh????------------------*/
	     rxposition_later=p->position+p->v*traffic.cell/(traffic.step*ONE_SECOND)*(propTime+txTime);


	     /*this car will receive the  warning only if in the tx range both at the beginning and at
	     the end of the transmission*/
	     /*other checks: - the car can not receive the warning if it is already transmitting
	                     - cars that pass the accident before the end of the reception of the warning 
			       are not considered*/
	     if(distanceNow < range && p->CAR_State!=TX && rxposition_later<=STREET_LENGTH && 
	       p->position>STREET_LENGTH-SecurityArea){
	          double rxtime;
		  if(algo == ALGO_D2FLOOD || algo == ALGO_D3FLOOD){
	             DBG_PL(TxInit,"dist now:%f min:%f"),distanceNow, p->minDist DBG_PR;
	             DBG_PL(TxInit,"(ptx:%f  p_rx:%f)"),p_tx->position,p->position DBG_PR;
		     if(p_tx->position<p->position){
		        p->minDist=0;			
		     }else if((distanceNow<p->minDist && p_tx->position>p->position) || p->minDist==0){
		        p->minDist=distanceNow;
		     }
		     /* back the old times of AWSN, it was that way 
		     Pflood = p->minDist/range;
		     Pflood = (k_d2flood<0) ? 1.0 : 1.0-pow((1.0-Pflood),k_d2flood+0.0);
		     */
		     Pflood = (algo == ALGO_D3FLOOD) ? 
		     		d3flood_pfwd(p->minDist/range, p->v/traffic.vmax) :
		     		d2flood_pfwd(p->minDist/range, p->v/traffic.vmax);
		   
	             DBG_PL(TxInit,"min dist:%f  pf:%f"), p->minDist,Pflood DBG_PR;
		  }
		  rxtime=current_time+propTime;
	          DBG_PL(TxInit,"propTime:%le"), propTime DBG_PR;
	          DBG_PL(TxInit,"car[%d]: w:%d distance=%f  rxtime:%f (mus)"),p->id,p->warning,distanceNow,rxtime DBG_PR;
		  
		  par.ptr = p;
		  par.id  = p->id;
		  par.idTx= p_tx->id;
		  par.vTx = p_tx->v;
		  par.xTx = p_tx->x;
		  par.Pf  = Pflood;	  
		  schedule(RX_INIT,rxtime,par);

		 if(someoneBack==0&&p_tx->position>p->position) {
		    someoneBack++;                    /*there is someone back*/
	            DBG_PL(TxInit,"car[%d] -- someone back=1"),p->id DBG_PR;
		  } 
             }
	}	
    p=p->prev;
    } while (p!=queue);
  

  /*check to know if it is the last (position) informed car*/
  /*the forwarding ends because no more cars are in the rx range*/
  if(someoneBack==0&&carback_new<carback){
     if(p_tx->position>STREET_LENGTH-SecurityArea+range)
       endxnoone_further=1;
     else
       endxnoone_further=0;
     endxcoll=0;
     endxnotx=0;
     carback=carback_new;
  }
  
  DBG_PL(TxInit,"endxnoone_further:%d"),endxnoone_further DBG_PR;     
  DBG_X(TxInit);
  }


void tx_end(EventParam par_in){
  Car *p;
  
  DBG_I(TxEnd);
  DBG_PL(TxEnd,"time:%f (mus)"),current_time DBG_PR;
  DBG_PL(TxEnd,"car:%d"),par_in.id DBG_PR;
  //printf("fine tx\n");
  p=par_in.ptr;
  p->CAR_State=DRIVE;
  p->TxEND=current_time;
  if (firstTx==1)
     firstTx=0;
  //printf("fine tx\n");
  DBG_X(TxEnd);
  }


void tx_tryagain(EventParam par_in){
  Car *p,*p_tx; 
  int go_on;
  double nexttime;  		
  double distanceNow;
  double propTime;
  
  DBG_I(TryAgain);
  DBG_PL(TryAgain,"time:%f (mus)"),current_time DBG_PR;
  DBG_PL(TryAgain,"car:%d"),par_in.id DBG_PR;

  if (queue==NULL)
       return;
  p_tx=par_in.ptr;

  if(p_tx->CAR_State==RX){
      DBG_PL(TryAgain,"E' in rx.... try later") DBG_PR;
      nexttime=uniform(0,31,&seed)*SlotTime+current_time;
      			
      schedule(TX_TRYAGAIN,nexttime, par_in);  
      return;
  }
  if(p_tx!=NULL){
 
	  go_on=1;

	  p = queue;  
	  do {
	     distanceNow=fabs(p_tx->position-p->position);
	     propTime=distanceNow/(3.0*1e2);
             double end=p->TxEND+propTime;
	     //DBG_PL(RxEnd,"Car[%d]: end:%f\n"),p->id,end DBG_PR;	  
	     if(abs(p_tx->position-p->position)<range && ((p->CAR_State==TX) || 
	       ((p->CAR_State==RX) && ((end)>=(current_time)) ))) {

		DBG_PL(TryAgain,"Car[%d] is transmitting"),p->id DBG_PR;	
		go_on=0;
		nexttime=uniform(0,31,&seed)*SlotTime+current_time;			
        	DBG_PL(TryAgain,"Try again at %f (mus)"),nexttime DBG_PR;			   
		schedule(TX_TRYAGAIN,nexttime, par_in);
		}
	     p=p->prev;   
	  } while (p!=queue && go_on==1);             

	  if(go_on==1){
	      schedule(TX_INIT,current_time, par_in);
	      }     		
  }          
  DBG_X(TryAgain);
  return;
}

void rx_init(EventParam par_in){
  Car *p;  /*receiving car*/
  double rxend;
  
  DBG_I(RxInit);
  DBG_PL(RxInit,"time:%f (mus)"),current_time DBG_PR;
  DBG_PL(RxInit,"Pf:%f"),par_in.Pf DBG_PR;
  
  p=par_in.ptr;
  p->Pf=par_in.Pf;
  
  if(p->CAR_State==TX) {
     DBG_PL(RxInit,"car %d is transmitting..."),par_in.id DBG_PR;
  } else {
     p->pkt_inrx++;
       if(p->CAR_State==RX){ /*if it is already receiving a packet, they will colide*/
 	 p->CAR_State=COLL;
       }       else { 
 	 p->CAR_State=RX;     /*else the reception starts*/ 
       }
     //p->CAR_State=RX;     /*else the reception starts*/ 
     rxend=current_time+rxTime;
     p->RxEND=rxend;
     schedule(RX_END,rxend,par_in);
  }
  
  DBG_PL(RxInit,"RX_INIT car:%d old:%f now:%f"),p->id,(current_time+rxTime),rxend DBG_PR;
  DBG_PL(RxInit,"RX_INIT car:%d state:%d pkt in rx:%d"),p->id,p->CAR_State,p->pkt_inrx DBG_PR;
  DBG_X(RxInit);
}

void wait(EventParam par_in){
  Car *p,*p_rx;
  int go_on ;
  int carback_new ;
  double next_time;  		
  double distanceNow,propTime;
  double prob;
  
  DBG_I(Wait);
  DBG_PL(Wait,"time:%f (mus)  car:%d"),current_time,par_in.id DBG_PR;
  p_rx=par_in.ptr;
  if(p_rx->firstWait==1){
    schedule(WAIT,current_time+1,par_in);
    // Phase has been used for exponential backoff
    // purposes; at first warning reception, set phase=1
    // 		p_rx->phase = 1;
    p_rx->firstWait=0;
    DBG_X(Wait);
    
  }else{
      if(algo == ALGO_D2FLOOD || algo == ALGO_D3FLOOD){
	    DBG_PL(Wait,"Nuovo wait (pkt in rx:%d)"),p_rx->rx DBG_PR;	   
	      p_rx->rx--;
	      /* AVOID Ddoing nasty things such as waiting for
		 pending reception to finish !!!*/
	      if(p_rx->rx==0&&p_rx->CAR_State!=RX){ 
		    prob=uniform01(&seed);	      
		    if(H_alfa >=0){   
		       histo_add(H_alfa, p_rx->Pf);	
		    }	
		    DBG_PL(Wait,"Pf:%f prob:%f"),p_rx->Pf,prob DBG_PR;	
		    if(prob<p_rx->Pf ){
        	      p_rx->relay=1;
		    }else{
        	      p_rx->relay=0;
		    }
	     } else{
		DBG_PL(Wait,"Nuovo wait (pkt in rx:%d state:%d)"),p_rx->rx,p_rx->CAR_State DBG_PR;	   

		/* ASWN'06 */
		/*
		next_time = current_time+2.0*txTime+uniform(0,31,&seed)*SlotTime;
		if (k_d2flood<0) 
 		  	next_time=current_time+uniform(0,4.0*txTime*(p_rx->minDist/range),&seed)*SlotTime;		  
		*/
		
		next_time = current_time + d2flood_time(p_rx->minDist/range, p_rx->v/traffic.vmax );			

		double exitT=current_time+(STREET_LENGTH-p_rx->position)/(p_rx->v*traffic.cell/(traffic.step*ONE_SECOND));
		if(next_time < exitT)
	    	    schedule(WAIT,next_time,par_in);
	     }
     }       
     if(p_rx->relay==1){
       go_on=1;
       p = queue;  
       do {
	  distanceNow=fabs(p_rx->position-p->position);
	  propTime=distanceNow/(3.0*1e2);
	  double end=p->TxEND+propTime;
	  //DBG_PL(Wait,"Car[%d]: end:%f\n"),p->id,end DBG_PR;	
	  if(abs(p_rx->position-p->position)<range && ((p->CAR_State==TX) || 
	    ((p->CAR_State==RX) && ((end)>=(current_time)) ))) {
	     /*someone else is transmitting: we tray later on */
	     DBG_PL(Wait,"Car[%d] is transmitting"),p->id DBG_PR;	
	     go_on=0;
	     next_time=uniform(0,31,&seed)*SlotTime+current_time;			
	     DBG_PL(RxEnd,"Try again at %f (mus)"),next_time DBG_PR;			       
	     
	     schedule(TX_TRYAGAIN,next_time, par_in);
	  }
	p=p->prev;   
	} while (p!=queue && go_on==1);		  

	if(go_on== 0 && (current_time-timeAccident)<txTime ) {
	  go_on=1;
	}	
	if(go_on==1) {
	   schedule(TX_INIT,current_time, par_in);     		
	} 

     /*to not Forward*/
     } else if (p_rx->relay==0) {
	 carback_new=carsComputing(&queue,p_rx->position);
	 DBG_PL(Wait,"carbacknew:%d back %d"),carback_new,carback DBG_PR;	
	 if(carback_new<carback){
	      endxnotx=1;
	      endxcoll=0;
	      endxnoone_further=0;
	      carback=carback_new;	
	 }           
     }
  }
  DBG_X(Wait);
}


void rx_end(EventParam par_in){

  double del;  /*time elapsed between the accident and the warning reception*/
  Car *p;
  Car *p_rx; //car that is receiving the warning*/
  int carback_new ;
  int go_on ;
  Coll *othercol,*coll;
  double nexttime;  		
  double distanceNow;
  double propTime;
    
  DBG_I(RxEnd);
  DBG_PL(RxEnd,"time:%f (mus)  car:%d"),current_time,par_in.id DBG_PR;

  p_rx=par_in.ptr;
  DBG_PL(RxEnd,"car:%d  state:%d  pf:%f"),p_rx->id,p_rx->CAR_State,p_rx->Pf DBG_PR;
  
  p_rx->rx++; 
  /*the received warning collided*/ 
  if (p_rx->CAR_State==COLL){ 
         p_rx->collided++; 

         DBG_PL(RxEnd,"car coll:%d  maxadv:%f"), par_in.id,maxadvised DBG_PR;
         
         /*to update the statistics: creation of a list of cars with 1 pkt collided.
	 When the second collided packet arrives the car is removed from the list.*/
	 
	 if (collision!=NULL)
	     othercol=find_coll(&collision,par_in.id);
         else
	     othercol=NULL;
	 
	 /*if it is in the list and there is collision -> it is the second one ->remove it*/
	 if(othercol!=NULL){
            DBG_PL(RxEnd,"othercoll:%d"),othercol->id DBG_PR;
            coll = out_list_coll(&collision,p_rx->id);
            release_coll(coll);

	 /*if it is not in the list and there is collision ->insert it*/
	 } else {
	   coll = new_coll();
	   coll->id=par_in.id;
	   in_list_coll(&collision,coll);  
	   
	   /*if it is the farest car to try to be informed - this can be the end of the forwarding*/
           carback_new=carsComputing(&queue,p_rx->position);
           if(carback_new<carback){
	       endxcoll=1;
	       endxnoone_further=0;
	       endxnotx=0;
	       carback=carback_new;
              }
         }
        DBG_PL(RxEnd,"car %d is colliding..."), par_in.id DBG_PR;

  /*the received warning is correct*/ 
  } else if (channel_error(par_in.id,par_in.idTx)) {
              DBG_PL(RxEnd,"pacchetto perso!!") DBG_PR;	   
  }else{
	   p_rx->last_rx_packet_end = current_time;

	   /*it is not a duplicate warning*/	   
	   if(p_rx->warning>0) {               		   
  	      DBG_PL(RxEnd,"Warning duplicato") DBG_PR;	
     	      	      
	   } else if(p_rx->warning==0) {               		   
	       del=current_time-timeAccident;
	       if(del>delay)
	          delay=del;
	       informed++;

		      
	       /*the forwarding is not finished yet!*/
               carback_new=carsComputing(&queue,p_rx->position);
               if(carback_new<carback){
	          endxnotx=0;
        	  endxnoone_further=0;	          
	       }
	      
	      if(algo == ALGO_COVERAGE){
                  double posVicino=p_rx->next->position;		  
		  double coverage;
		  if(par_in.idTx!=-1)
		     coverage=par_in.xTx*traffic.cell-range;
                  else
		     coverage=par_in.xTx-range;
		  DBG_PL(RxEnd,"my:%f vicino:%f coverage:%f"),p_rx->position,p_rx->next->position,coverage DBG_PR;
		  if(coverage>posVicino){
		      p_rx->relay=1;		
	          }else{
		      p_rx->relay=0;		
	          }
	          DBG_PL(RxEnd,"relay:%d"),p_rx->relay DBG_PR;	

	      }	else if(algo == ALGO_D2FLOOD || algo == ALGO_D3FLOOD){
		  p_rx->relay=-1;  
		  // double waitTime=current_time+2*txTime;		     

		  double waitTime;
		  
	     /* ASWN'06 */
	     /*
		  if (k_d2flood<0) 
		  	waitTime=current_time+uniform(0,4.0*txTime*(p_rx->minDist/range),&seed)*SlotTime;		  
		  else
		  	waitTime=current_time+2.0*txTime+uniform(0,31,&seed)*SlotTime;		  
	     */
			
	     waitTime = current_time + d2flood_time(p_rx->minDist/range, p_rx->v/traffic.vmax );			
		// printf("%f %f %f\n",current_time, waitTime, waitTime-current_time);			
			
	          double exitT=current_time+(STREET_LENGTH-p_rx->position)/(p_rx->v*traffic.cell/(traffic.step*ONE_SECOND));
		  if(exitT>waitTime)
		  	schedule(WAIT,waitTime, par_in);
	          p_rx->CAR_State=WAIT;
		  

 	      }	else if((algo == ALGO_HELP) || (algo == ALGO_HYBRID)) {
	          help_rx_end(par_in);

 	      }	

             if( p_rx->relay ==1) {  	      
		  go_on=TRUE;
		  p = queue;  
		  do {
		    distanceNow=fabs(p_rx->position-p->position);
		    propTime=distanceNow/(3.0*1e2);
		    double end=p->TxEND+propTime;
		    //DBG_PL(RxEnd,"Car[%d]: end:%f\n"),p->id,end DBG_PR;	
		    if(abs(p_rx->position-p->position)<range && ((p->CAR_State==TX) || 
		      ((p->CAR_State==RX) && ((end)>=(current_time)) ))) {
		       /*someone else is transmitting: we tray later on */
		       DBG_PL(RxEnd,"Car[%d] is transmitting"),p->id DBG_PR;	
		       go_on=FALSE;
		       
		       //nexttime=uniform(0,5,&seed)*txTime+current_time;			    		       		       
	    	       nexttime=uniform(0,31,&seed)*SlotTime+current_time;			
		       
		       DBG_PL(RxEnd,"Try again at %f (mus)"),nexttime DBG_PR;			       
		       schedule(TX_TRYAGAIN,nexttime, par_in);
		    }
		  p=p->prev;   
		  } while ((p!=queue) && go_on);		  

		  if(go_on || ((go_on==FALSE) && (current_time-timeAccident)<txTime)) {
  	             schedule(TX_INIT,current_time, par_in);     		
        	  } 

	      /*to not Forward*/
	      } else if (p_rx->relay==0) {
	          
        	  carback_new=carsComputing(&queue,p_rx->position);
 	          DBG_PL(RxEnd,"carbacknew:%d back %d"),carback_new,carback DBG_PR;	
         	  if(carback_new<carback){
	               endxnotx=1;
		       endxcoll=0;
		       endxnoone_further=0;
	      	       carback=carback_new;	
		  }           
	      }
	  } 
	  
	  /*update of the max distance reached with the warning*/
	  if(STREET_LENGTH-p_rx->position>maxadvised){
	       maxadvised=STREET_LENGTH-p_rx->position;
	  }	  
	  /*total number of warning received by the considered car (may be duplicate)*/
          p_rx->warning++; 
  }

	  
  
  p_rx->pkt_inrx--;
  if(p_rx->pkt_inrx==0)
       p_rx->CAR_State=DRIVE;
  DBG_PL(RxEnd,"car:%d  state:%d  pkt in rx:%d  coll:%d"),p_rx->id,p_rx->CAR_State,p_rx->pkt_inrx,p_rx->collided DBG_PR;
  DBG_PL(RxEnd,"endxcoll:%d endxnoone:%d  exnxnotx:%d"),endxcoll,endxnoone_further,endxnotx DBG_PR;
  if(p_rx->pkt_inrx==-1){  /*error!!!*/
       fprintf(stderr,"Something went terribly wrong. (pkt -1)\n");
       exit(2);
  }     
  DBG_X(RxEnd);
}



int simula()
{
 Event *ev;
 int i,tot;
 double perc ;
 EventParam par;
 par.id=-1;
 par.ptr=NULL;

 init_var();

  timeHello=60*(double)ONE_SECOND;
  if ((algo == ALGO_HELP) || (algo == ALGO_HYBRID))
  	schedule(HELLO,timeHello,par); 

  if((algo == ALGO_HELP) || (algo == ALGO_HYBRID))
      timeFirstAccident=timeHello+(MAX_CICLI_HELLO*HelloFreq+uniform(0.0,HelloFreq,&seed))*(double)ONE_SECOND; 
  else 
      timeFirstAccident=(double)uniform(2,5,&seed)*60*(double)ONE_SECOND; 
  //printf("TFA:%f\n",timeFirstAccident/(double)ONE_SECOND);
  
  if(traffic.model == TRAFFIC_NBNA){
     double time=negexp(1.0/lambda,&seed);
     schedule(CAR_ARRIVAL,time,par);
     schedule(UPDATE,time,par);
  }else{
     schedule(UPDATE,0,par);
  }
  if (algo != ALGO_NONE) {
     // that is, unless we are testing the traffic model,
     // an accident has to be scheduled
     if(AI!=0){
        //multiples broadcast cycle: for "min" minutes every "AI" minutes
	for (i=0; i<=min/AI;i++)
	   schedule(ACCIDENT,timeFirstAccident+i*AI*1e6,par);
     }else{
        //generation of one broadcast cycle only
	schedule(ACCIDENT,timeFirstAccident,par); 
     }
 }    
 

 while (current_time<maximum_time)
  {
    ev = get_event(&event_list);
    if(ev!=NULL) {
	  last_event_time = current_time;
	  current_time = ev->time;
	  switch (ev->type)
	   {
	     case CAR_ARRIVAL: car_arrival(0);
			    break;
	     case CAR_EXIT: carExit();
			    break;
	     case UPDATE: update();
			    break;
	     case ACCIDENT: accident();
			    break;
	     case TX_INIT: tx_init(ev->par);
			    break;
	     case TX_END:  tx_end(ev->par);
			    break;
	     case RX_INIT: rx_init(ev->par);
			    break;
	     case RX_END: rx_end(ev->par);
			    break;
	     case TX_TRYAGAIN: tx_tryagain(ev->par);
			    break;
	     case WAIT:  wait(ev->par);
			    break;
	     case HELLO: hello();		    
			    break;
	     case HELLO_TX: hello_tx(ev->par);		    
			    break;
	     case HELLO_TX_END: hello_tx_end(ev->par);		    
			    break;
	     case HELLO_RX: hello_rx(ev->par);		    
			    break;
	     case HELLO_RX_END: hello_rx_end(ev->par);		    
			    break;
	     default:       
	     	fprintf(stderr,"Event of unkown type. You've definitively inserted an awful memory bug!!\n");
		exit(1);
	   }
	  release_event(ev);
	}  else{   
              current_time=maximum_time+1;
         }
  }  
  
  perc=informed/(double)(cars_accidentTime);
//    printf("%f %f  %f\n",traffic.density,traffic.flow, traffic.v);
//    printf(" %f  (%d %d)\n",perc,informed,cars_accidentTime);
// if(uiDebugMask==-1)
 //   printf("info_perc:%f\n",perc);
  if(perc==1){
       endxnoone_further=0;
       endxcoll=0;
       endxnotx=0;
       d_statistics(8,0);
  } else {
       d_statistics(8,1);
  }    

  d_statistics(1,perc);
  d_statistics(2,maxadvised);
  b_statistics(3,endxnoone_further);
  b_statistics(4,endxcoll);
  b_statistics(5,endxnotx);
  b_statistics(6,informed);
  b_statistics(7,totW);
  if( H_dRelay >=0){ 
      int last=0, first=0,dist;
      for(i=0;i<1000;i++){
         //printf("D[%d]=%d\n",i,Dfwd[i]);
	 if(Dfwd[i]==1&&first==0){ 
            last=i;
            first=1;
	 }else if(Dfwd[i]==1&&first!=0){
            dist=i-last;
            //printf("last:%d dist:%d\n",last,dist);
	    histo_add(H_dRelay, dist);	
            last=i;
	 }
      }   	
  }	 
  if( H_1D>=0 ){
      	   histo_add(H_1D, delay/1.0e6);
  }	
  while(queue!=NULL){
    carExit();
  }

  if(event_list!=NULL)
    while(event_list!=NULL){ 
    Event *ev = get_event(&event_list);
    release_event(ev);
  }

  while(collision!=NULL){
    Coll *ev = out_list_coll2(&collision);
    release_coll(ev);
  }

/*correzione a posteriori: c'e' stato un sorpasso dell'ultimo minuto*/
  tot=cars_accidentTime-carback-informed-collided;
  //printf("tot:%d Accident:%d  back:%d info:%d coll:%d \n",tot,total_cars_final,carback,informed,collided);
  if(tot==-1||tot==-2){
     carback--;
  }
  tot=cars_accidentTime-carback-informed-collided;
  
  if(endxnoone_further){  
      tot_noinfo_backoorange+=carback;
  }else  if(endxcoll){
      tot_noinfo_backcoll+=carback;
  }else  if(endxnotx){
      tot_noinfo_notx+=carback;
  }else{
      tot_noinfo_other+=carback;
  }
  
  if(uiDebugMask == -1){
    fclose(fhpDebugFile);
  }
  return 0;
}


void end_simulation_run(void) {
     run_on=FALSE;
     out_global_results();
}



void quit(int signal) {
    histo_dump_all();
    channel_done();
    fclose(fileout);
    exit(0);   
}



int main(int argc, char** argv)
{
 int i;    
 
 input_parameters(argc,argv);
 signal(SIGINT, quit);   /* Ctrl-C exits gracefully */

 init_stat();
 //seed=1;  
// for (i=0; (i<MIN_CYCLES) ||(run_on && i<MAX_CYCLES); i++) {
 //NORMAL:
 for (i=0; run_on && i<MAX_CYCLES; i++) {
    if(i%10==0) {
       fprintf(stderr,"\rSimulation:%d",i);
       fflush(stdout);
    }  
    seed=time(0)*(i+1);
    simula();

     if(channel.model == CHANNEL_ERROR_FREE)
     fprintf(diaf,"%f %f %f %f %f/\n",
	 traffic.density,
	 traffic.flow,
	 traffic.v*traffic.cell/traffic.step*3.6, 
	 (double) informed/(double)(cars_accidentTime),
	 (double) totW/(double)(cars_accidentTime));
 }
 
 fprintf(stderr,"\rTotal runs:%d\n",i);
 quit(0);
 return 0;
}


